using UnityEngine;

namespace Damage
{
    [SkipSerialisation]
    class HealthGunOrganBehaviour : EffectGunBehaviour
    {
        protected override void Affect(Collider2D coll)
        {
            LimbBehaviour limb;
            if (!TryGetLimb(coll, out limb) || limb.IsAndroid)
                return;
            limb.HealBone();
            limb.Health = limb.InitialHealth;
            limb.CirculationBehaviour.HealBleeding();
            limb.SkinMaterialHandler.AcidProgress *= 0.25f;
            limb.SkinMaterialHandler.RottenProgress = 0.0f;
            limb.PhysicalBehaviour.BurnProgress *= 0.8f;
            limb.Numbness *= 0.0f;
            limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
            limb.CirculationBehaviour.BloodFlow = 1f;
            limb.CirculationBehaviour.ClearLiquid();
            limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), 1f);
            limb.Frozen = false;

            if (limb.gameObject.TryGetComponent(out HumanDamageBehaviour damage))
            {
                damage.HealBone();
                damage.RepairLimb();
                if (damage.hasOrgan)
                {
                    foreach (Organ organ in damage.organs)
                    {
                        damage.RepairOrgan(organ);
                    }
                }
            }

            if (limb.RoughClassification != LimbBehaviour.BodyPart.Head)
                return;
            limb.Person.ShockLevel = 0.0f;
            limb.Person.PainLevel = 0.0f;
            limb.Person.AdrenalineLevel = 1f;
            limb.Person.Consciousness += 0.5f;
        }
    }
}