using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Damage
{
    public class HemostatBehaviour : MonoBehaviour, Messages.IUse
    {
        public Collider2D[] results = new Collider2D[8];
        ContactFilter2D filter;
        Collider2D col;
        void Start()
        {
            filter = new ContactFilter2D();
            filter.SetLayerMask(LayerMask.GetMask("Objects"));
        }
        public void Use(ActivationPropagation propogation)
        {
            if (!col)
                col = GetComponent<Collider2D>();
            Physics2D.OverlapCollider(col, filter, results);
            foreach (Collider2D col in results)
            {
                if (col && col.TryGetComponent(out LimbBehaviour limb) && !limb.IsAndroid)
                {
                    bool used = false;
                    if (limb.CirculationBehaviour.BleedingRate != 0)
                    {
                        limb.CirculationBehaviour.BleedingRate = 0;
                        used = true;
                    }
                    if (limb.TryGetComponent(out HumanDamageBehaviour damage) && damage.hasOrgan)
                    {
                        foreach (Organ organ in damage.organs)
                        {
                            if (organ.bleedRate > 0)
                            {
                                organ.bleedRate = 0;
                                used = true;
                            }
                        }
                    }
                    if (!used)
                        continue;
                    Destroy(gameObject);
                }
            }
        }
        void OnCollisionEnter2D(Collision2D collision)
        {
            if (collision.gameObject.GetComponent<LimbBehaviour>())
            {
                Nocollide(collision.gameObject);
            }
        }
        public void Nocollide(GameObject col)
        {
            NoCollide noCol = gameObject.AddComponent<NoCollide>();
            noCol.NoCollideSetA = GetComponents<Collider2D>();
            noCol.NoCollideSetB = col.GetComponents<Collider2D>();
        }
    }
}