using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace Damage
{
    public class DamageBehaviour : MonoBehaviour
    {
        // note this code sucks ass

        public PersonBehaviour person;
        public LimbBehaviour limb;
        // Bigger = More likely it will get damaged
        // 1 or more means it will always be damaged
        private float organSize;
        public float organHealth;
        float initialHealth;
        float previousHealth;
        //public List<float> organEfficiency;
        public Organ organ;
        public bool organDestroyed;
        public bool hasOrgan;
        public float organPosition = -2;

        private ContactPoint2D[] contactBuffer = new ContactPoint2D[8];
        public bool bluntDamageOrgans = true;

        public OrganType organType;

        public bool fracturedBone;
        public float fractureChance = .15f;
        public float jointDestroyChance = .025f;

        // Chance that an injured organ will be instantly destroyed
        public float criticalChance = .05f;

        // Multiple Organ Stuff
        // i put too much focus on this why
        public bool lungs;
        public float lungHealth = 60f;
        public float lungEfficiency = 1f;
        public bool lungsDestroyed;

        public float organEfficiency;

        public bool vitalOrganDestroyed;

        public float storedShockLevel;
        public bool shock;

        public LimbBehaviour head;
        public PersonBehaviour headPerson;

        public LimbBehaviour[] allLimbs;

        public JointAngleLimits2D normalLimits;

        void Start()
        {
            ModAPI.Notify("<color=red>Advanced Damage: This human is outdated! Please replace them with a new one immediately.</color>");
            ModAPI.Notify("<color=red>If you are saving a contraption, please make sure to disable automatic applying by double pressing M when replacing this human, so corruption isn't a risk.</color>");
            Destroy(this);
            return;
            limb = GetComponent<LimbBehaviour>();
            person = limb.Person;
            normalLimits = limb.Joint.limits;
            if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
            {
                organ = Organ.Brain;
                organType = OrganType.Brain;
                organSize = 1f;
                organHealth = limb.Health;
                organHealth = 10f;
                organPosition = -.05f;
                hasOrgan = true;
                allLimbs = person.Limbs;
                foreach (LimbBehaviour limbb in limb.ConnectedLimbs)
                {
                    limbb.GetComponent<DamageBehaviour>().head = limb;
                }
            }
            if (gameObject.name == "UpperBody")
            {
                organ = Organ.Chest;
                organType = OrganType.Heart;
                organSize = 1f;
                organHealth = 80f;
                lungs = true;
                hasOrgan = true;
            }
            initialHealth = organHealth;
            if (limb.RoughClassification == LimbBehaviour.BodyPart.Legs)
            {
                limb.CirculationBehaviour.BloodLossRateMultiplier = 2;
            }
            if (limb.RoughClassification == LimbBehaviour.BodyPart.Arms)
            {
                limb.CirculationBehaviour.BloodLossRateMultiplier = 2.5f;
            }
            StartCoroutine(SlowUpdate());

            PhysicalBehaviour phys = GetComponent<PhysicalBehaviour>();
            PhysicalProperties prop = ScriptableObject.CreateInstance<PhysicalProperties>();
            PhysicalProperties human = ModAPI.FindPhysicalProperties("Human");

            prop.SoftImpact = human.SoftImpact;
            prop.HardImpact = human.HardImpact;
            prop.ShotImpact = human.ShotImpact;
            prop.PhysicMaterial = human.PhysicMaterial;
            prop.SharpForceThresholdMultiplier = human.SharpForceThresholdMultiplier;
            prop.ImpactIntensityMutliplier = human.ImpactIntensityMutliplier;
            prop.HitVolumeMultiplier = human.HitVolumeMultiplier;
            prop.LodgeStrengthMultiplier = human.LodgeStrengthMultiplier;
            prop.StabSound = human.StabSound;
            prop.SlidingLoop = human.SlidingLoop;
            prop.Sharp = human.Sharp;
            prop.SharpAxes = human.SharpAxes;
            prop.Softness = human.Softness;
            prop.Brittleness = human.Brittleness;
            prop.Burnrate = human.Burnrate;
            prop.Conducting = human.Conducting;
            prop.MagneticAttractionIntensity = human.MagneticAttractionIntensity;
            prop.Flammability = human.Flammability;
            prop.Buoyancy = human.Buoyancy;

            prop.BulletSpeedAbsorptionPower = 2f;
            phys.Properties = prop;
        }

        void Update()
        {
            Destroy(this);
            return;
            if (lungs)
            {
                if (head.Person)
                    headPerson = head.Person;
                //if (limb.Health <= 0 && !lungsDestroyed)
                //DestroyOrgan(OrganType.Lungs);

                if (headPerson)
                {
                    if (lungEfficiency != 1f)
                    {
                        float efficiency = Mathf.Clamp(lungEfficiency * 25, 10f, 42.5f);
                        if (headPerson.OxygenLevel > 0)
                            headPerson.OxygenLevel -= Time.deltaTime / efficiency;
                        //person.AddPain(Time.deltaTime * 60 / lungHealth);
                    }
                    if (headPerson.OxygenLevel <= 0)
                        vitalOrganDestroyed = true;
                }
            }
            if (!vitalOrganDestroyed)
            {
                if (limb.CirculationBehaviour && !limb.CirculationBehaviour.IsPump)
                {
                    limb.CirculationBehaviour.IsPump = true;
                }
                if (organ == Organ.Brain || organ == Organ.Chest)
                {
                    limb.Health = organHealth;
                    if (limb.Health <= 0)
                        organHealth = 0;
                }
            }
        }
        public void Stabbed(Stabbing stab)
        {
            bool syringe = false;
            List<Component> components = new List<Component>();
            foreach (var component in stab.stabber.GetComponents<Component>())
            {
                if (component.GetType().IsSubclassOf(typeof(SyringeBehaviour)) && !syringe)
                    syringe = true;
            }
            if (syringe == true)
                return;
            //ModAPI.Notify("STABBED BY " + stab.stabber + " IN " + stab.victim);
            float rng = UnityEngine.Random.value;
            rng *= 1.25f;
            float fracturerng = UnityEngine.Random.value;
            float criticalChance = UnityEngine.Random.value;
            float damage = UnityEngine.Random.Range(0, initialHealth * .5f);
            if (transform.InverseTransformPoint(stab.point).y > organPosition)
            {
                if (organ == Organ.Brain)
                {
                    damage = 25f;
                    rng *= 1.25f;
                }
            }
            else
            {
                organHealth -= damage / 1.5f;
            }
            if (fracturerng <= .05f && !fracturedBone)
            {
                FractureBone();
            }
            if (!organDestroyed)
            {
                if (rng <= organSize)
                {
                    organHealth -= damage;
                    //ModAPI.Notify(organ.ToString() + " Damaged");
                }
            }
            if (lungs && lungHealth > 0.01f)
            {
                float lungrng = UnityEngine.Random.value;

                if (lungrng <= .7f)
                {
                    lungHealth -= damage;
                    //ModAPI.Notify("Lungs Damaged");
                    lungEfficiency = lungHealth / 60;

                    if (lungHealth <= 0f)
                    {
                        DestroyOrgan(OrganType.Lungs);
                    }
                }
            }
            person.AdrenalineLevel = 25;
            StartCoroutine(EnterShock());
        }

        private void Shot(global::Shot shot)
        {
            person.AdrenalineLevel = 75;
            float rng = UnityEngine.Random.value;
            float fracturerng = UnityEngine.Random.value;
            float criticalChance = UnityEngine.Random.value;

            float damage = shot.damage * 2;
            if (fracturerng <= fractureChance && !fracturedBone)
            {
                if (limb.RoughClassification == LimbBehaviour.BodyPart.Arms || limb.RoughClassification == LimbBehaviour.BodyPart.Legs)
                    FractureBone();
            }
            if (!organDestroyed && hasOrgan)
            {
                if (transform.InverseTransformPoint(shot.point).y > organPosition || organPosition == -2)
                {
                    if (rng <= organSize)
                    {
                        if (organ == Organ.Brain)
                        {
                            person.AdrenalineLevel = 0;
                            if (organHealth <= 0)
                            {
                                foreach (LimbBehaviour limb1 in limb.ConnectedLimbs)
                                {
                                    limb1.GetComponent<DamageBehaviour>().vitalOrganDestroyed = true;
                                }
                            }
                            damage = shot.damage * 2;
                        }
                        organHealth -= damage;
                        //ModAPI.Notify(organ.ToString() + " Damaged");
                    }
                }
                else
                {
                    organHealth -= damage / 5f;
                    if (organ == Organ.Brain)
                        person.Consciousness = 0;
                }
                if (organ == Organ.Chest)
                {
                    organHealth -= damage / UnityEngine.Random.Range(20, 30);
                    lungHealth -= damage / UnityEngine.Random.Range(20, 30);
                }
            }
            if (lungs && lungHealth > 0f)
            {
                float lungrng = UnityEngine.Random.value;

                if (lungrng <= .7f)
                {
                    lungHealth -= damage;
                    //ModAPI.Notify("Lungs Damaged");
                    lungEfficiency = lungHealth / 60;

                    if (lungHealth <= 0f)
                    {
                        DestroyOrgan(OrganType.Lungs);
                    }
                }
            }
            if (limb.Health > 0)
            {
                if (limb.HasJoint)
                    StartCoroutine(Stiffen(limb.Joint, 5f));

                foreach (LimbBehaviour limbBehaviour in limb.ConnectedLimbs)
                {
                    if (limbBehaviour.HasJoint && limbBehaviour.RoughClassification == limb.RoughClassification)
                        limbBehaviour.StartCoroutine(limbBehaviour.GetComponent<DamageBehaviour>().Stiffen(limbBehaviour.Joint, 5f));
                }
            }
            foreach (LimbBehaviour limbs in limb.ConnectedLimbs)
            {
                limbs.Damage(Mathf.Clamp01(shot.damage / limbs.Health));
            }
            StartCoroutine(EnterShock());
        }

        // why does this exist
        // why did i do this
        // was there a reason why i did this

        public enum Organ { None, Chest, Brain };

        public enum OrganType { None, Brain, Heart, Lungs }

        public void FractureBone()
        {
            if (!limb.IsZombie)
            {
                fracturedBone = true;
                limb.BaseStrength /= 3;
                person.PainLevel += 20f;
            }
        }

        public void DestroyOrgan(OrganType type)
        {
            //ModAPI.Notify(type.ToString() + " Destroyed");
            if (type == OrganType.Brain || type == OrganType.Heart)
                vitalOrganDestroyed = true;
            if (type == OrganType.Lungs)
            {
                lungEfficiency = 0f;
                lungsDestroyed = true;
            }
            else
                organDestroyed = true;
        }
        public void RepairOrgan(OrganType type)
        {
            //ModAPI.Notify(type.ToString() + " Repaired");
            if (type == OrganType.Brain || type == OrganType.Heart)
            {
                vitalOrganDestroyed = false;
                organHealth = initialHealth;
                limb.Health = limb.InitialHealth;
                limb.CirculationBehaviour.IsPump = true;
                foreach (LimbBehaviour limber in limb.ConnectedLimbs)
                {
                    HealParts(limber);
                }
            }
            if (type == OrganType.Lungs)
            {
                if (lungs)
                {
                    lungEfficiency = 1;
                    lungHealth = 60f;
                    lungsDestroyed = false;
                }
            }
            person.ShockLevel = 0f;
            organDestroyed = false;
        }
        public void RepairBone()
        {
            fracturedBone = false;
            limb.BaseStrength = 5f;
        }
        public void ExitShock(float exitconsciousness)
        {
            // this code is bad and useless  but im to lazy to fix it
            shock = false;
            person.ShockLevel = storedShockLevel;
            person.Consciousness = exitconsciousness;
            storedShockLevel = 0;
        }
        public IEnumerator EnterShock()
        {
            while (person.AdrenalineLevel > 0)
            {
                if (!shock)
                {
                    storedShockLevel = person.ShockLevel;
                }
                shock = true;
                person.ShockLevel = 0f;
                // i dont know what im doing
                if (person.Consciousness > .6f)
                    person.Consciousness = 1f;
                else
                    person.Consciousness -= .05f;
                yield return null;
            }
            //ExitShock(.75f);
        }
        public void HealParts(LimbBehaviour limbe)
        {
            foreach (LimbBehaviour limber in limbe.ConnectedLimbs)
            {
                DamageBehaviour damage = limber.GetComponent<DamageBehaviour>();
                if (damage.vitalOrganDestroyed)
                {
                    damage.vitalOrganDestroyed = false;
                    HealParts(limber);
                    limber.CirculationBehaviour.IsPump = true;
                }
            }
        }
        public IEnumerator InternalBleeding()
        {
            yield return null;
        }
        public IEnumerator Stiffen(HingeJoint2D joint, float length)
        {
            if (limb.gameObject.name != "UpperArm" && limb.gameObject.name != "UpperLeg" && limb.gameObject.name != "UpperArmFront" && limb.gameObject.name != "UpperLegFront")
            {
                JointAngleLimits2D limits = joint.limits;

                limits.min /= 2;
                limits.max /= 2;

                joint.limits = limits;

                yield return new WaitForSeconds(length);
                joint.limits = normalLimits;
            }
        }
        void OnCollisionEnter2D(Collision2D collision)
        {
            // i dont understand what this is but im sure zooi does
            float impulse = ((IEnumerable<ContactPoint2D>)this.contactBuffer).Take<ContactPoint2D>(collision.GetContacts(this.contactBuffer)).Max<ContactPoint2D>((Func<ContactPoint2D, float>)(c => c.normalImpulse));
            if (impulse > .75f && bluntDamageOrgans)
            {
                float rng = UnityEngine.Random.value;
                float lungrng = UnityEngine.Random.value;
                float fracturerng = UnityEngine.Random.value;
                if (rng < .45f && hasOrgan && !organDestroyed)
                {
                    organHealth -= impulse * 10;
                }
                if (fracturerng < .25f)
                {
                    FractureBone();
                }
                if (lungrng < .75 && lungs && !lungsDestroyed)
                    if (lungs)
                        lungHealth -= impulse * 10;
            }
        }
        IEnumerator SlowUpdate()
        {
            for (; ; )
            {
                if (GetComponent<LifePoison>() && hasOrgan || GetComponent<LifePoison>() && fracturedBone)
                {
                    limb.CirculationBehaviour.IsPump = true;
                    vitalOrganDestroyed = false;
                    if (hasOrgan && organDestroyed)
                    {
                        RepairOrgan(organType);
                    }
                    if (lungs)
                    {
                        RepairOrgan(OrganType.Lungs);
                    }
                    if (fracturedBone)
                    {
                        RepairBone();
                    }
                    //if (shock)
                    //    ExitShock(1f);
                }
                // Checks if it has an organ, if true, runs through the behaviour of organs
                if (hasOrgan)
                {
                    if (head && !limb.ConnectedLimbs.Contains(head))
                    {
                        vitalOrganDestroyed = true;
                    }
                    if (organ == Organ.Brain)
                    {
                        int dead = 0;
                        foreach (LimbBehaviour limb1 in person.Limbs)
                        {
                            DamageBehaviour damage = limb1.GetComponent<DamageBehaviour>();
                            if (limb1.Health <= 0)
                            {
                                dead++;
                            }
                        }
                        if (dead > 10)
                        {
                            vitalOrganDestroyed = true;
                        }
                    }
                    if (!organDestroyed && !GetComponent<LifePoison>())
                    {
                        if (organHealth <= 0)
                        {
                            DestroyOrgan(organType);
                        }
                    }
                    if (!vitalOrganDestroyed)
                    {
                        if (organ == Organ.Brain && limb.IsDismembered || organ == Organ.Brain && limb.Broken)
                        {
                            vitalOrganDestroyed = true;
                            organHealth = 0;
                        }
                    }
                    if (vitalOrganDestroyed && !GetComponent<LifePoison>())
                    {
                        if (limb.CirculationBehaviour)
                        {
                            limb.CirculationBehaviour.IsPump = false;
                        }
                        foreach (LimbBehaviour limb1 in person.Limbs)
                        {
                            DamageBehaviour damage = limb1.GetComponent<DamageBehaviour>();
                            if (damage && damage.vitalOrganDestroyed == false)
                            {
                                damage.vitalOrganDestroyed = true;
                            }
                        }
                    }
                }
                yield return new WaitForSeconds(.5f);
            }
        }
    }
}